`ifdef __SMV__

  scalarset [23:0] ADDR;
  typedef [31:0] WORD;
  typedef enum {tx_low, tx_high} STATE;

  `define ADDR ADDR
  `define WORD WORD
  `define STATE STATE
  `define tx_low tx_low
  `define tx_high tx_high

`else

  `define ADDR [23:0]
  `define WORD [31:0]
  `define STATE
  `define `tx_low 0
  `define `tx_high 1

`endif


module ROM_impl(clk,addr_inp, data_out, stall);	
   input  clk;
   input  `ADDR addr_inp;
   output `WORD data_out;
   output stall;
   
   /* state machine */
   
   reg `STATE state;
   initial state = `tx_low;
   always @(posedge clk)
      if(state == `tx_low)
	 state = `tx_high;
      else state = `tx_low;
   
   assign stall = (state == `tx_low);
   
   /* low address register */
   
   reg [11:0] low_reg;
   // smv breaking(ADDR)
     always @(posedge clk)
        if(state == `tx_low)
	   low_reg = addr_inp[11:0];
   // smv endbreaking
      
   /* reconstruct the address */
   
   wire `ADDR impl_addr;
   // smv breaking(ADDR)
      assign impl_addr = {addr_inp[23:12],low_reg};
   // smv endbreaking
   
   /* an instance of a ROM */
   ROM24x32 ROM(impl_addr,data_out);
   
endmodule // ROM_impl
