`define SIZE 16
`define LOG_SIZE 4
module main(alloc,nack,alloc_addr,free,free_addr);
  input alloc;
  output nack;
  output [(`LOG_SIZE-1):0] alloc_addr;
  input free;	
  input [(`LOG_SIZE-1):0] free_addr;

  reg busy[0:(`SIZE - 1)];
  reg count[`LOG_SIZE:0];

  initial begin
    busy = 0;
    count = 0;
  end

  always begin
    nack = alloc & (count == `SIZE);
    count = count + (alloc & ~nack) - (free);
  end

  always begin
    if(free) busy[free_addr] = 0;
    if(alloc & ~nack) busy[alloc_addr] = 1;
  end
 
  always begin
    for(i = (`SIZE - 1); i >= 0; i = i - 1)
      if (~busy[i]) alloc_addr = i;
  end

  /* assertions follow */

  /* definition of when a buffer is freed and allocated */

  wire [0:(`SIZE - 1)] allocd, freed;
  for(i = 0; i < `SIZE; i = i +1)
   always
      begin
        allocd[i] = alloc & ~nack & alloc_addr == i;
        freed[i] = free & free_addr == i;
      end


  /* if an entry is allocated, it is not allocated again until freed */

  for(i = 0; i < `SIZE; i = i + 1)
    always begin
      if (allocd[i]) begin
	wait(1);
        while(~freed[i]) begin
          assert safe[i]: ~allocd[i];
          wait(1);
        end
        assert safe[i]: ~allocd[i];
      end
    end

endmodule

